<template>
  <div class="shop">
    <section class="hero">
      <img
        src="https://www.shutterstock.com/image-photo/portrait-excited-beautiful-girl-wearing-600nw-1038849250.jpg"
        alt="Hero Image"
      />
      <div class="hero-text">
        <h2>Welcome to Our Shop</h2>
        <p>Discover the best products for all your needs</p>
      </div>
    </section>

    <section
      id="categories"
      class="categories"
    >
      <div
        class="category-item"
        v-for="category in categories"
        :key="category.id"
      >
        <CategoryCard :category="category" />
      </div>
    </section>

    <section id="products" class="products">
      <div class="product-list">
        <ProductCard
          v-for="product in products"
          :key="product.id"
          :product="product && product"
        />
      </div>
    </section>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import CategoryCard from "@/components/CategoryCard.vue";
import ProductCard from "@/components/ProductCard.vue";
export default {
  name: "ProductList",

  components: { CategoryCard, ProductCard },

  computed: {
    ...mapGetters(["getCategories", "getProducts", "getCartCount"]),
    categories() {
      return this.getCategories;
    },
    products() {
      return this.getProducts;
    },
    cartCount() {
      return this.getCartCount;
    },
  },
  async mounted() {
    await this.loadCategories();
    await this.loadProducts();
  },
  methods: {
    ...mapActions(["fetchCategories", "fetchProducts"]),
    loadCategories() {
      this.fetchCategories();
    },
    loadProducts() {
      this.fetchProducts();
    },
  },
  filters: {
    currency(value) {
      return `$${parseFloat(value).toFixed(2)}`;
    },
  },
};
</script>

<style scoped>
h1 {
  font-size: 32px;
  margin-bottom: 20px;
}
.category-list {
  display: flex;
}

.categories {
  margin-top: 32px;
  display: flex;
  flex-wrap: wrap;
  justify-content: space-around;
  padding: 0 10%;
}

h2 {
  font-size: 24px;
  margin-bottom: 10px;
}
.products {
  margin-top: 64px;
  padding: 0 10%;
}
.product-list {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
  gap: 20px;
}

.hero {
  position: relative;
  text-align: center;
  color: white;
}

.hero img {
  width: 100%;
  height: 500px;
  border-radius: 5px;
  object-fit: cover;
  object-position: 70% 20%;
}

.hero-text {
  position: absolute;
  top: 50%;
  left: 25%;
  transform: translate(-50%, -50%);
  background: rgba(0, 0, 0, 0.5);
  padding: 20px;
  border-radius: 10px;
}

.hero-text h2 {
  margin: 0;
  font-size: 2.5em;
}

.hero-text p {
  margin: 10px 0 0;
  font-size: 1.2em;
}
@media only screen and (max-width: 600px) {
  .hero-text {
    visibility: hidden;
  }
  .product-list {
    justify-content: center;
  }
}
</style>
